Index: /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 2237)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 2332)
@@ -304,5 +304,5 @@
 
 
-void HierarchyManager::EvalSubdivisionStats()
+void HierarchyManager::PrintSubdivisionStats()
 {
 	
@@ -492,14 +492,15 @@
 
 	// create first nodes
-	mVspTree->Initialise(sampleRays, forcedViewSpace);
+	mVspTree->Initialise(sampleRays, forcedViewSpace, objects);
 	InitialiseObjectSpaceSubdivision(objects);
 
 	// hack: assume that object space can be seen from view space
-	mHierarchyStats.mTotalCost = mInitialRenderCost = (float)objects.size();
+	mHierarchyStats.mTotalCost = mInitialRenderCost = GetViewCellsManager()->ComputeRenderCost(objects.size(), 1);
+
 	// only one entry for start
 	mHierarchyStats.mPvsEntries = 1;
 	mHierarchyStats.mMemory = (float)ObjectPvs::GetEntrySizeByte();
 
-	EvalSubdivisionStats();
+	PrintSubdivisionStats();
 	Debug << "setting total cost to " << mHierarchyStats.mTotalCost << endl;
 
@@ -678,9 +679,9 @@
 	mHierarchyStats.mPvsEntries = 1;
 	mHierarchyStats.mMemory = (float)ObjectPvs::GetEntrySizeByte();
-	mHierarchyStats.mTotalCost = (float)objects.size();
+	mHierarchyStats.mTotalCost = GetViewCellsManager()->ComputeRenderCost(objects.size(), 1);
 
 	mHierarchyStats.mRenderCostDecrease = 0;
 
-	EvalSubdivisionStats();
+	PrintSubdivisionStats();
 	Debug << "setting total cost to " << mHierarchyStats.mTotalCost << endl;
 
@@ -689,5 +690,5 @@
 	
 	// create only roots
-	mVspTree->Initialise(sampleRays, forcedViewSpace);
+	mVspTree->Initialise(sampleRays, forcedViewSpace, objects);
 	InitialiseObjectSpaceSubdivision(objects);
 
@@ -745,6 +746,9 @@
 	//-- new stats
 
-	mHierarchyStats.mTotalCost = mVspTree->mTotalCost;
-	cout << "\nreseting cost for vsp, new total cost: " << mHierarchyStats.mTotalCost << endl;
+	if (0)
+	{
+		mHierarchyStats.mTotalCost = mVspTree->mTotalCost;
+		cout << "\nreseting cost for vsp construction, new total cost: " << mHierarchyStats.mTotalCost << endl;
+	}
 }
 
@@ -960,5 +964,5 @@
 
 	// output stats
-	EvalSubdivisionStats();
+	PrintSubdivisionStats();
 
 	return true;
@@ -1223,5 +1227,5 @@
 
 			// evaluate stats before first subdivision
-			EvalSubdivisionStats();
+			PrintSubdivisionStats();
 			cout << "finished bv hierarchy preparation" << endl;
 		}
@@ -1241,5 +1245,5 @@
 												 AxisAlignedBox3 *forcedViewSpace)
 {
-	ViewCellsManager *vm = mVspTree->mViewCellsManager;
+	ViewCellsManager *vm = GetViewCellsManager();
 
 	// HACK: rather not destroy vsp tree
@@ -1250,8 +1254,10 @@
 	mVspTree->mViewCellsManager = vm;
 
-	mVspTree->Initialise(sampleRays, forcedViewSpace);
+	mVspTree->Initialise(sampleRays, forcedViewSpace, objects);
+	
 	
 	//////////
 	//-- reset stats
+
     mHierarchyStats.mNodes = GetObjectSpaceSubdivisionNodes();
 		//-mVspTree->mVspStats.nodes + 1;
@@ -1266,5 +1272,5 @@
 
 	// evaluate new stats before first subdivsiion
-	EvalSubdivisionStats();
+	PrintSubdivisionStats();
 }
 
@@ -1278,5 +1284,5 @@
 	mHierarchyStats.mNodes = 2;
 	
-	mHierarchyStats.mTotalCost = (float)objects.size();
+	mHierarchyStats.mTotalCost = GetViewCellsManager()->ComputeRenderCost(objects.size(), 1);
 	Debug << "setting total cost to " << mHierarchyStats.mTotalCost << endl;
 
@@ -1285,5 +1291,5 @@
 	
 	// initialise view / object space
-	mVspTree->Initialise(sampleRays, forcedViewSpace);
+	mVspTree->Initialise(sampleRays, forcedViewSpace, objects);
 	InitialiseObjectSpaceSubdivision(objects);
 
@@ -1987,5 +1993,5 @@
 
 void HierarchyManager::ComputePvs(const ObjectPvs &pvs, 
-								  float &rc, 
+								  float &triangles, 
 								  int &pvsEntries)
 {
@@ -2026,7 +2032,7 @@
 			ObjectContainer objects;
             activeNode->CollectObjects(objects);
-			rc += mBvHierarchy->EvalAbsCost(objects);
+			triangles += (float)objects.size();
 #else
-			rc += mBvHierarchy->GetRenderCostIncrementially(activeNode);
+			triangles += mBvHierarchy->GetTriangleSizeIncrementially(activeNode);
 #endif
 			++ pvsEntries;
@@ -2232,6 +2238,5 @@
 	{
 		ViewCell *vc = *vit;
-		float rc = 0;
-        
+		
 #if STUPID_METHOD	
 		ObjectPvs pvs;
@@ -2254,25 +2259,33 @@
 		vc->Mail();
 
+		float triangles = 0;
+		int entries = 0;
+
 		if (useFilter)
 		{
 			const long startT = GetTime();
+			
 			ObjectPvs filteredPvs;
-			mVspTree->mViewCellsManager->ApplyFilter2(vc, false, 1.0f, filteredPvs);
+			GetViewCellsManager()->ApplyFilter2(vc, false, 1.0f, filteredPvs);
+
 			const long endT = GetTime();
 
 			//cout << "filter computed in " << TimeDiff(startT, endT) * 1e-3f << " secs" << endl;
-			ComputePvs(filteredPvs, rc, pvsEntries);
+			
+			ComputePvs(filteredPvs, triangles, entries);
 		}
 		else
 		{
-			ComputePvs(vc->GetPvs(), rc, pvsEntries);
-			vc->SetPvsCost(rc);
-		}
-
-		rc *= vc->GetVolume();
+			ComputePvs(vc->GetPvs(), triangles, entries);
+			vc->SetPvsCost(triangles);
+		}
+
+		const float rc = GetViewCellsManager()->ComputeRenderCost((int)triangles, entries) * vc->GetVolume();
+		
 		renderCost += rc;
-	}
-
-	renderCost /= mVspTree->mViewCellsManager->GetViewSpaceBox().GetVolume();
+		pvsEntries += entries;
+	}
+
+	renderCost /= GetViewCellsManager()->GetViewSpaceBox().GetVolume();
 	memory = pvsEntries * ObjectPvs::GetEntrySize();
 
@@ -2297,5 +2310,5 @@
 		const string filename = string(statsPrefix) + string(str);
 
-		mVspTree->mViewCellsManager->EvalViewCellHistogramForPvsSize(filename, viewCells);
+		GetViewCellsManager()->EvalViewCellHistogramForPvsSize(filename, viewCells);
 
 		histoUsed = true;
@@ -2322,181 +2335,11 @@
 
 
-void HierarchyManager::ExportStats(ofstream &stats, 
-								   SplitQueue &tQueue, 
-								   const ObjectContainer &objects)
-{
-	HierarchySubdivisionStats subStats;
-	subStats.Reset();
-
-	/////////////
-	//-- initial situation
-
-	subStats.mNumSplits = 0;
-	subStats.mTotalRenderCost = (float)objects.size();
-	subStats.mEntriesInPvs = 1;
-	subStats.mMemoryCost = (float)ObjectPvs::GetEntrySize();
-	subStats.mFullMemory = subStats.mMemoryCost;
-	subStats.mViewSpaceSplits = 0;
-	subStats.mObjectSpaceSplits = 0;
-	subStats.mRenderCostDecrease = 0;
-	subStats.Print(stats);
-
-	cout << "exporting vsposp stats ... " << endl;
-
-	//-- go through tree in the order of render cost decrease
-	//-- which is the same order as the view cells were merged
-	//-- or the reverse order of subdivision for subdivision-only 
-	//-- view cell hierarchies.
-
-	while (!tQueue.Empty())
-	{
-		SubdivisionCandidate *nextCandidate = NextSubdivisionCandidate(tQueue);
-		bool isLeaf;
-		int timeStamp;
-		//float rcDecr; 
-		//int entriesIncr; 
-
-		if (nextCandidate->Type() == SubdivisionCandidate::VIEW_SPACE)
-		{
-			timeStamp = (int)-nextCandidate->GetPriority();
-
-			VspNode *newNode = mVspTree->SubdivideAndCopy(tQueue, nextCandidate);
-			VspNode *oldNode = (VspNode *)nextCandidate->mEvaluationHack;
-
-			isLeaf = newNode->IsLeaf();
-			//subStats.mRenderCostDecrease = oldNode->mRenderCostDecr;
-			//entriesIncr = oldNode->mPvsEntriesIncr;
-		}
-		else
-		{
-			timeStamp = (int)-nextCandidate->GetPriority();
-
-			BvhNode *newNode = mBvHierarchy->SubdivideAndCopy(tQueue, nextCandidate);
-			BvhNode *oldNode = (BvhNode *)nextCandidate->mEvaluationHack;
-
-			isLeaf = newNode->IsLeaf();
-			//subStats.mRenderCostDecrease = oldNode->mRenderCostDecr;
-			//entriesIncr = oldNode->mPvsEntriesIncr;
-		}		
-
-		if (!isLeaf)
-		{
-			subStats.mTotalRenderCost -= subStats.mRenderCostDecrease;
-			//subStats.mEntriesInPvs += entriesIncr;
-
-			if (nextCandidate->Type() == SubdivisionCandidate::VIEW_SPACE)
-			{
-				++ subStats.mViewSpaceSplits;
-				//cout << "v";
-				//cout << "vsp t: " << timeStamp << " rc: " << rcDecr << " pvs: " << entriesIncr << endl;
-			}
-			else
-			{
-				++ subStats.mObjectSpaceSplits;
-				//cout << "o";
-				//"osp t: " << timeStamp << " rc: " << rcDecr << " pvs: " << entriesIncr << endl;
-			}
-
-			++ subStats.mNumSplits;
-
-			if ((subStats.mNumSplits % 500) == 499)
-				cout << subStats.mNumSplits << " steps taken" << endl;
-
-			subStats.mMemoryCost = (float)subStats.mEntriesInPvs * (float)ObjectPvs::GetEntrySize();
-			subStats.mFullMemory = subStats.mMemoryCost;
-
-			subStats.Print(stats);
-
-		}
-
-		DEL_PTR(nextCandidate);
-	}
-
-	stats.close();
-}
-
-
-void HierarchyManager::EvaluateSubdivision(const VssRayContainer &sampleRays,
-										   const ObjectContainer &objects,
-										   const string &filename)
-{
-#if 0
-	VspTree *oldVspTree = mVspTree;
-	ViewCellsManager *vm = mVspTree->mViewCellsManager;
-	BvHierarchy *oldHierarchy = mBvHierarchy;
-
-	mBvHierarchy = new BvHierarchy();
-	mBvHierarchy->mHierarchyManager = this;
-	mBvHierarchy->mViewCellsManager = vm;
-
-	mVspTree = new VspTree();
-	mVspTree->mHierarchyManager = this;
-	mVspTree->mViewCellsManager = vm;
-
-	// create first nodes
-	mVspTree->Initialise(sampleRays, &oldVspTree->mBoundingBox);
-	InitialiseObjectSpaceSubdivision(objects);
-
-	const long startTime = GetTime();
-	cout << "Constructing evaluation hierarchies ... \n";
-	
-	ofstream stats;
-	stats.open(filename.c_str());
-	SplitQueue tQueue;
-
-	BvhNode *oldBvhRoot = oldHierarchy->GetRoot();
-	VspNode *oldVspRoot = oldVspTree->GetRoot();
-
-	RayInfoContainer *viewSpaceRays = new RayInfoContainer();
-	
-	SubdivisionCandidate *firstVsp = mVspTree->PrepareConstruction(sampleRays, *viewSpaceRays);
-	tQueue.Push(firstVsp);
-
-	mBvHierarchy->PrepareConstruction(tQueue, sampleRays, objects);
-
-    firstVsp->mEvaluationHack = oldVspRoot;
-	firstBvh->mEvaluationHack = oldBvhRoot;
-
-	firstVsp->SetPriority((float)-oldVspRoot->mTimeStamp);
-	firstBvh->SetPriority((float)-oldBvhRoot->GetTimeStamp());
-	
-	ExportStats(stats, tQueue, objects);
-
-	cout << "\nfinished in " << TimeDiff(startTime, GetTime()) * 1e-3 << " secs" << endl;
-	RemoveRayRefs(objects);
-
-	// view cells needed only for evaluation
-	ViewCellContainer viewCells;
-	mVspTree->CollectViewCells(viewCells, false);
-	
-	// helper trees can be destroyed
-	DEL_PTR(mVspTree);
-	DEL_PTR(mBvHierarchy);
-
-	CLEAR_CONTAINER(viewCells);
-
-	// reset hierarchies
-	mVspTree = oldVspTree;
-	mBvHierarchy = oldHierarchy;
-
-	// reinstall old bv refs
-	vector<BvhLeaf *> leaves;
-	mBvHierarchy->CollectLeaves(mBvHierarchy->GetRoot(), leaves);
-	vector<BvhLeaf *>::const_iterator bit, bit_end = leaves.end();
-
-	for (bit = leaves.begin(); bit != bit_end; ++ bit)
-	{
-		mBvHierarchy->AssociateObjectsWithLeaf(*bit);
-	}
-#endif
-}
-
-
-void HierarchyManager::EvaluateSubdivision2(ofstream &splitsStats,
-											const int splitsStepSize,
-											const bool useFilter,
-											const bool useHisto,
-											const int histoMem,
-											const int pass)
+
+void HierarchyManager::EvaluateSubdivision(ofstream &splitsStats,
+										   const int splitsStepSize,
+										   const bool useFilter,
+										   const bool useHisto,
+										   const int histoMem,
+										   const int pass)
 {
 	vector<HierarchySubdivisionStats> subStatsContainer;
@@ -2645,12 +2488,18 @@
 	if (!mTraversalTree)
 	{
-		return mVspTree->CastLineSegment(origin,termination, viewcells, useMailboxing);
+		return mVspTree->CastLineSegment(origin, termination, viewcells, useMailboxing);
 	}
 	else
 	{
-		return mTraversalTree->CastLineSegment(origin,termination, viewcells, useMailboxing);
-	}
-}
-
-
-}
+		return mTraversalTree->CastLineSegment(origin, termination, viewcells, useMailboxing);
+	}
+}
+
+
+ViewCellsManager *HierarchyManager::GetViewCellsManager() 
+{
+	return mVspTree->mViewCellsManager;
+}
+
+
+}
